        .messg "equate"
        .subttl "equate"
        .page

; Equates
bit0            .equ    %00000001
bit1            .equ    %00000010
bit2            .equ    %00000100
bit3            .equ    %00001000
bit4            .equ    %00010000
bit5            .equ    %00100000
bit6            .equ    %01000000
bit7            .equ    %10000000
all             .equ    %11111111

buff0           .equ    $0300           ; buffers
buff1           .equ    $0400
buff2           .equ    $0500
buff3           .equ    $0600
buff4           .equ    $0700
buff5           .equ    $0800
buff6           .equ    $0900
bam1            .equ    $0a00           ; trk 1-40
bam2            .equ    $0b00           ; trk 41-80
buffcache       .equ    $0c00           ; 20 pages for track cache (10KB)
cache_high      .equ    $20

skip1           .equ    $24             ; bit zp
skip2           .equ    $2c             ; bit abs
numjob          .equ    8               ; number of jobs
notfnd          .equ    6
lrf             .equ    $80             ; last record flag
dyfile          .equ    $40             ; dirty flag for rr file
ovrflo          .equ    $20             ; rr print overflow
nssl            .equ    6               ; # of side-sector links
systrack        .equ    40              ; system track
sysdirsec       .equ    3               ; system directory sector
sysiz           .equ    2               ; default sector size
sysiob          .equ    $c0             ; iobyte default
dtos            .equ    $8f             ; default top of stack
zpvar           .equ    2               ; zp start

; offset into ss for dat blk ptrs

ssioff          .equ    4+nssl+nssl

nssp            .equ    120             ; # of ptrs in ss
mxchns          .equ    7               ; max # channels in system
maxsa           .equ    18              ; max sa # +1
cr              .equ    13              ; carriage return
bindx           .equ    16              ; bam offset index
bfcnt           .equ    7               ; available  buffer count

; command buffer ptr

cbptr           .equ    bfcnt+bfcnt+4

; error channel #

errchn          .equ    mxchns-1

errsa           .equ    16              ; error channel sa #

; command channel #

cmdchn          .equ mxchns-2

; pwr up linuse (logical index usage)

lxint           .equ    %00011111

cmdsa           .equ    15              ; command channel sa #
apmode          .equ    2               ; open append mode
mdmode          .equ    3               ; open modify mode
wtmode          .equ    1               ; open write mode
reltyp          .equ    4               ; open relative type
dirtyp          .equ    7               ; open direct type
partyp          .equ    5               ; open partition type
seqtyp          .equ    1               ; open sequential type
prgtyp          .equ    2               ; open program type
usrtyp          .equ    3               ; open user type
typmsk          .equ    7               ; mask for type bits
irsa            .equ    17              ; internal read sa #
iwsa            .equ    18              ; internal write sa #

; controller jobs

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
read_dv         .equ    $80             ; Read into track cache buffer.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

reset_dv        .equ    $82             ; Reset disk controller.
moton_dv        .equ    $84             ; Turn on spindle motor w/ spinup sequence.
motoff_dv       .equ    $86             ; Turn off spindle motor w/ spin down sequence.
motoni_dv       .equ    $88             ; Turn on spindle motor.
motoffi_dv      .equ    $8a             ; Turn off spindle motor.
seek_dv         .equ    $8c             ; Move head to a specific cylinder.
format_dv       .equ    $8e             ; Format one cylinder side.

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
wrtsd_dv        .equ    $90             ; Write out track cache buffer.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

diskin_dv       .equ    $92             ; Determine if a disk present in the drive.

ledacton_dv     .equ    $94             ; Will turn on the activity led.
ledactoff_dv    .equ    $96             ; Will turn off the activity led.

errledon_dv     .equ    $98             ; Will enable error led blinking.
errledoff_dv    .equ    $9a             ; Will disable error led blinking.

side_dv         .equ    $9c             ; Will select side.
bufmove_dv      .equ    $9e             ; Will move data from/to a specific area
                                        ; in the track cache buffer.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
wrtver_dv       .equ    $a0             ; Track cache verify write.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

trkwrt_dv       .equ    $a2             ; Will dump track cache buffer to disk.
pread_dv        .equ    $a4             ; Read sector notranslation.
pwrt_dv         .equ    $a6             ; Write sector notranslation.
pseek_dv        .equ    $a8             ; Move head to a specific logical cylinder.
tread_dv        .equ    $aa             ; Read sector notrx.
twrt_dv         .equ    $ac             ; Write sector notrx.

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
seekhd_dv       .equ    $b0             ; Seek any header.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

tpread_dv       .equ    $b2             ; Read sector notranslation, notrx.
tpwrt_dv        .equ    $b4             ; Write sector notranslation, notrx.
detwp_dv        .equ    $b6             ; Check write protect status

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
seekphd_dv      .equ    $b8             ; Sector seek a particular header.
restore_dv      .equ    $c0             ; Restore head against track zero stop.
jumpc_dv        .equ    $d0             ; Execute buffer.
exbuf_dv        .equ    $e0             ; Execute buffer after motor is up to
                                        ; speed and on track.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

formatdk_dv     .equ    $f0             ; Format diskette.

precmptrk       .equ    43              ; precompensation starts at track 43
mxfils          .equ    5               ; max # filenames in string
dirlen          .equ    24              ; directory length used
nbsiz           .equ    27              ; nambuf text size
cmdlen          .equ    41              ; length of command buffer

